package de.fitko.fitconnect.api.domain.model.metadata.data;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;

import java.util.Arrays;

public enum DataSignatureType {

    SHA_512("sha512");
    private final String value;

    DataSignatureType(final String value) {
        this.value = value;
    }

    @Override
    public String toString() {
        return this.value;
    }

    @JsonValue
    public String value() {
        return this.value;
    }

    @JsonCreator
    public static DataSignatureType fromValue(final String value) {
        return Arrays.stream(DataSignatureType.values())
                .filter(enumValue -> enumValue.value.equals(value))
                .findFirst()
                .orElseThrow(() -> new IllegalArgumentException("Unexpected value '" + value + "'"));
    }

}
