package de.fitko.fitconnect.api.domain.model.metadata.data;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;

import java.util.Arrays;

public enum MimeType {

    APPLICATION_JSON("application/json"),
    APPLICATION_XML("application/xml");

    private final String value;

    MimeType(final String value) {
        this.value = value;
    }

    @Override
    public String toString() {
        return this.value;
    }

    @JsonValue
    public String value() {
        return this.value;
    }

    @JsonCreator
    public static MimeType fromValue(final String value) {
        return Arrays.stream(MimeType.values())
                .filter(enumValue -> enumValue.value.equals(value))
                .findFirst()
                .orElseThrow(() -> new IllegalArgumentException("Unexpected value '" + value + "'"));
    }
}
