package de.fitko.fitconnect.client.cmd.commands;

import com.beust.jcommander.Parameter;
import com.beust.jcommander.Parameters;
import de.fitko.fitconnect.client.cmd.util.UUIDConverter;
import de.fitko.fitconnect.client.cmd.util.UUIDValidator;

import java.util.UUID;

import static de.fitko.fitconnect.client.cmd.commands.ListAllSubmissionsCommand.LIST_CMD_NAME;

@Parameters(
        commandNames = {LIST_CMD_NAME},
        commandDescription = "Lists available submissions",
        separators = "="
)
public
class ListAllSubmissionsCommand {

    public static final String LIST_CMD_NAME = "list";

    @Parameter(names = { "--destinationId" }, description = "Unique destination identifier in UUID format", converter = UUIDConverter.class,  validateWith = UUIDValidator.class, arity = 1, required = true)
    public
    UUID destinationId;
}
