package de.fitko.fitconnect.client.cmd.util;

import de.fitko.fitconnect.api.domain.model.metadata.data.MimeType;

public enum AttachmentDataType {

    JSON("json"), XML("xml");

    private final String fileType;

    AttachmentDataType(final String fileType) {
        this.fileType = fileType;
    }

    public static String getFileTypeFromMimeType(final MimeType mimeType) {
        switch (mimeType) {
            case APPLICATION_JSON:
                return JSON.fileType;
            case APPLICATION_XML:
                return XML.fileType;
            default:
                return null;
        }
    }

}
